/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140210-00 [Feb 10 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000036A (874)
 *     Revision         0x01
 *     Checksum         0x00
 *     OEM ID           "APPLE "
 *     OEM Table ID     "CpuPm"
 *     OEM Revision     0x00021500 (136448)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20140210 (538182160)
 */

DefinitionBlock ("ssdt.aml", "SSDT", 1, "APPLE ", "CpuPm", 0x00021500)
{
    External (\_PR_.CPU0, DeviceObj)
    External (\_PR_.CPU1, DeviceObj)
    External (\_PR_.CPU2, DeviceObj)
    External (\_PR_.CPU3, DeviceObj)
    External (\_PR_.CPU4, DeviceObj)
    External (\_PR_.CPU5, DeviceObj)
    External (\_PR_.CPU6, DeviceObj)
    External (\_PR_.CPU7, DeviceObj)
    External (\_PR_.CPU8, DeviceObj)
    External (\_PR_.CPU9, DeviceObj)
    External (\_PR_.CPUA, DeviceObj)
    External (\_PR_.CPUB, DeviceObj)
    External (\_PR_.CPUC, DeviceObj)
    External (\_PR_.CPUD, DeviceObj)
    External (\_PR_.CPUE, DeviceObj)
    External (\_PR_.CPUF, DeviceObj)
    External (\_PR_.CPUG, DeviceObj)
    External (\_PR_.CPUH, DeviceObj)
    External (\_PR_.CPUI, DeviceObj)
    External (\_PR_.CPUJ, DeviceObj)
    External (\_PR_.CPUK, DeviceObj)
    External (\_PR_.CPUL, DeviceObj)
    External (\_PR_.CPUM, DeviceObj)
    External (\_PR_.CPUN, DeviceObj)

    Scope (\_PR_.CPU0)
    {
        Name (APLF, Zero)
        Name (APSN, Zero)
        Name (APSS, Package (0x0E)
        {
            /* High Frequency Modes (non-turbo) */
            Package (0x06) { 0x0D84, 0x01FBD0, 0x0A, 0x0A, 0x001A, 0x001A },
            Package (0x06) { 0x0D05, 0x019CDE, 0x0A, 0x0A, 0x0019, 0x0019 },
            Package (0x06) { 0x0C80, 0x017232, 0x0A, 0x0A, 0x0018, 0x0018 },
            Package (0x06) { 0x0BFA, 0x014A91, 0x0A, 0x0A, 0x0017, 0x0017 },
            Package (0x06) { 0x0B75, 0x0125DF, 0x0A, 0x0A, 0x0016, 0x0016 },
            Package (0x06) { 0x0AF0, 0x010400, 0x0A, 0x0A, 0x0015, 0x0015 },
            Package (0x06) { 0x0A6A, 0x00E4D5, 0x0A, 0x0A, 0x0014, 0x0014 },
            Package (0x06) { 0x09E5, 0x00AE2E, 0x0A, 0x0A, 0x0013, 0x0013 },
            Package (0x06) { 0x0960, 0x009676, 0x0A, 0x0A, 0x0012, 0x0012 },
            Package (0x06) { 0x08DB, 0x008100, 0x0A, 0x0A, 0x0011, 0x0011 },
            Package (0x06) { 0x0855, 0x006DB0, 0x0A, 0x0A, 0x0010, 0x0010 },
            Package (0x06) { 0x07D0, 0x005C67, 0x0A, 0x0A, 0x000F, 0x000F },
            Package (0x06) { 0x074B, 0x004D09, 0x0A, 0x0A, 0x000E, 0x000E },
            Package (0x06) { 0x06C5, 0x003F7A, 0x0A, 0x0A, 0x000D, 0x000D },
            /* Low Frequency Mode */
            Package (0x06) { 0x0640, 0x002952, 0x0A, 0x0A, 0x000C, 0x000C }
        })

        Method (ACST, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU0.ACST Called", Debug)
            Store ("CPU0 C-States    : 29", Debug)

            /* Low Power Modes for CPU0 */
            Return (Package (0x06)
            {
                One,
                0x04,
                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000000, // Address
                            0x01,               // Access Size
                            )
                    },
                    One,
                    Zero,
                    0x03E8
                },

                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000010, // Address
                            0x03,               // Access Size
                            )
                    },
                    0x03,
                    0xCD,
                    0x01F4
                },

                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000020, // Address
                            0x03,               // Access Size
                            )
                    },
                    0x06,
                    0xF5,
                    0x015E
                },

                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000030, // Address
                            0x03,               // Access Size
                            )
                    },
                    0x07,
                    0xF5,
                    0xC8
                }
            })
        }
    }

    Scope (\_PR_.CPU1)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU1.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU1.ACST Called", Debug)
            Store ("CPU1 C-States    : 7", Debug)

            /* Low Power Modes for CPU1 */
            Return (Package (0x05)
            {
                One,
                0x03,
                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000000, // Address
                            0x01,               // Access Size
                            )
                    },
                    One,
                    0x03E8,
                    0x03E8
                },

                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000010, // Address
                            0x03,               // Access Size
                            )
                    },
                    0x02,
                    0x94,
                    0x01F4
                },

                Package (0x04)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW,
                            0x01,               // Bit Width
                            0x02,               // Bit Offset
                            0x0000000000000030, // Address
                            0x03,               // Access Size
                            )
                    },
                    0x03,
                    0xC6,
                    0xC8
                }
            })
        }
    }

    Scope (\_PR_.CPU2)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU2.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU3)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU3.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU4)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU4.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU5)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU5.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU6)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU6.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU7)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU7.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU8)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU8.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPU9)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPU9.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUA)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUA.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUB)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUB.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUC)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUC.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUD)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUD.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUE)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUE.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUF)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUF.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUG)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUG.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUH)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUH.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUI)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUI.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUJ)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUJ.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUK)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUK.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUL)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUL.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUM)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUM.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }

    Scope (\_PR_.CPUN)
    {
        Method (APSS, 0, NotSerialized)
        {
            Store ("Method _PR_.CPUN.APSS Called", Debug)

            Return (\_PR_.CPU0.APSS)
        }

        Method (ACST, 0, NotSerialized) { Return (\_PR_.CPU1.ACST ()) }
    }
}
